// XYZ frame for pick and place unit

// XYZ system parameters
frame=[690, 910, 200]; // frame XYZ
beam=[40, 40]; // beam size XY
xpos=910/3.7; // Position of the X-gantry for imaging (could be animated!)

// T-slot beam module with or without motor
module tslot(length=100, startposition=[0,0,0], rotation=[0,0,0]){
    translate(startposition) rotate(rotation) linear_extrude(height = length, center = false, convexity = 1)
    import (file = "profile2.dxf", layer = "0");  
}
// Draw up the basic beams (parameterized)
tslot(frame[1],[0,0,0],[0,90,0]);
tslot(frame[1],[0,frame[0]-2*(beam[0]),0],[0,90,0]);
tslot(frame[0]-2*(beam[0]),[0,beam[0],0],[-90,0,0]);
tslot(frame[0]-2*(beam[0]),[frame[1]-(beam[0]),beam[0],0],[-90,0,0]);
// add the X-beam at height 300 - beam height mm 
tslot(frame[0],[xpos,0,(frame[2]-beam[1])],[-90,0,0]);

// Add the side panels Y Gantry mockup


// Add the X gantry

// Add the X gantry
module ygantry(length=100, startposition=[0,0,0], rotation=[0,0,0]){
    translate(startposition) rotate(rotation) linear_extrude(height = length, center = false, convexity = 1)
    import (file = "ygantry.dxf", layer = "0");  
}

// Adding the NEMA motors from the MCAD library
// https://github.com/openscad/MCAD/blob/master/stepper.scad
// includes
include <MCAD/stepper.scad>
// Y-Motor
translate([(beam[0])/2,frame[0]-(beam[0]),-20]) rotate([-90,0,0]) motor(Nema17, NemaMedium, dualAxis=false);
// X motor
translate([xpos,frame[0]-(beam[0]),frame[2]-1.5*beam[0]]) rotate([-90,0,90]) motor(Nema17, NemaMedium, dualAxis=false);
//translate([20,frame[0],300]) rotate([-90,0,0]) motor(Nema17, NemaMedium, dualAxis=-1)